diff --git a/src/cxx.cc b/src/cxx.cc
index a0e92ac..0ead3f0 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -200,65 +200,100 @@ void cxxbridge02$unique_ptr$std$string$drop(
 } // extern "C"
 
 #define STD_VECTOR_OPS(RUST_TYPE, CXX_TYPE)                                    \
-  extern "C" {                                                                 \
-  size_t cxxbridge02$std$vector$##RUST_TYPE##$length(                          \
+  size_t cxxbridge02$std$vector$##RUST_TYPE##$size(                            \
       const std::vector<CXX_TYPE> &s) noexcept {                               \
     return s.size();                                                           \
   }                                                                            \
-  void cxxbridge02$std$vector$##RUST_TYPE##$push_back(                         \
-      std::vector<CXX_TYPE> &s, const CXX_TYPE &item) noexcept {               \
-    s.push_back(item);                                                         \
-  }                                                                            \
   const CXX_TYPE *cxxbridge02$std$vector$##RUST_TYPE##$get_unchecked(          \
       const std::vector<CXX_TYPE> &s, size_t pos) noexcept {                   \
     return &s[pos];                                                            \
   }                                                                            \
-  static_assert(sizeof(::std::unique_ptr<std::vector<CXX_TYPE>>) ==            \
-                    sizeof(void *),                                            \
-                "");                                                           \
-  static_assert(alignof(::std::unique_ptr<std::vector<CXX_TYPE>>) ==           \
-                    alignof(void *),                                           \
-                "");                                                           \
-  void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$null(                   \
-      ::std::unique_ptr<std::vector<CXX_TYPE>> *ptr) noexcept {                \
-    new (ptr)::std::unique_ptr<std::vector<CXX_TYPE>>();                       \
+  void cxxbridge02$std$vector$##RUST_TYPE##$push_back(                         \
+      std::vector<CXX_TYPE> &s, const CXX_TYPE &item) noexcept {               \
+    s.push_back(item);                                                         \
   }                                                                            \
-  void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$new(                    \
-      ::std::unique_ptr<std::vector<CXX_TYPE>> *ptr,                           \
-      std::vector<CXX_TYPE> *value) noexcept {                                 \
-    new (ptr)::std::unique_ptr<std::vector<CXX_TYPE>>(                         \
-        new std::vector<CXX_TYPE>(::std::move(*value)));                       \
+  void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$null(                   \
+      std::unique_ptr<std::vector<CXX_TYPE>> *ptr) noexcept {                  \
+    new (ptr) std::unique_ptr<std::vector<CXX_TYPE>>();                        \
   }                                                                            \
   void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$raw(                    \
-      ::std::unique_ptr<std::vector<CXX_TYPE>> *ptr,                           \
+      std::unique_ptr<std::vector<CXX_TYPE>> *ptr,                             \
       std::vector<CXX_TYPE> *raw) noexcept {                                   \
-    new (ptr)::std::unique_ptr<std::vector<CXX_TYPE>>(raw);                    \
+    new (ptr) std::unique_ptr<std::vector<CXX_TYPE>>(raw);                     \
   }                                                                            \
-  const std::vector<CXX_TYPE> *                                                \
-      cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$get(                     \
-          const ::std::unique_ptr<std::vector<CXX_TYPE>> &ptr) noexcept {      \
+  const std::vector<CXX_TYPE>                                                  \
+      *cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$get(                    \
+          const std::unique_ptr<std::vector<CXX_TYPE>> &ptr) noexcept {        \
     return ptr.get();                                                          \
   }                                                                            \
-  std::vector<CXX_TYPE> *                                                      \
-      cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$release(                 \
-          ::std::unique_ptr<std::vector<CXX_TYPE>> &ptr) noexcept {            \
+  std::vector<CXX_TYPE>                                                        \
+      *cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$release(                \
+          std::unique_ptr<std::vector<CXX_TYPE>> &ptr) noexcept {              \
     return ptr.release();                                                      \
   }                                                                            \
   void cxxbridge02$unique_ptr$std$vector$##RUST_TYPE##$drop(                   \
-      ::std::unique_ptr<std::vector<CXX_TYPE>> *ptr) noexcept {                \
+      std::unique_ptr<std::vector<CXX_TYPE>> *ptr) noexcept {                  \
     ptr->~unique_ptr();                                                        \
+  }
+
+#define RUST_VEC_EXTERNS(RUST_TYPE, CXX_TYPE)                                  \
+  void cxxbridge02$rust_vec$##RUST_TYPE##$new(                                 \
+      rust::Vec<CXX_TYPE> *ptr) noexcept;                                      \
+  void cxxbridge02$rust_vec$##RUST_TYPE##$drop(                                \
+      rust::Vec<CXX_TYPE> *ptr) noexcept;                                      \
+  size_t cxxbridge02$rust_vec$##RUST_TYPE##$len(                               \
+      const rust::Vec<CXX_TYPE> *ptr) noexcept;                                \
+  const CXX_TYPE *cxxbridge02$rust_vec$##RUST_TYPE##$data(                     \
+      const rust::Vec<CXX_TYPE> *ptr) noexcept;                                \
+  size_t cxxbridge02$rust_vec$##RUST_TYPE##$stride() noexcept;
+
+#define RUST_VEC_OPS(RUST_TYPE, CXX_TYPE)                                      \
+  template <>                                                                  \
+  Vec<CXX_TYPE>::Vec() noexcept {                                              \
+    cxxbridge02$rust_vec$##RUST_TYPE##$new(this);                              \
+  }                                                                            \
+  template <>                                                                  \
+  void Vec<CXX_TYPE>::drop() noexcept {                                        \
+    return cxxbridge02$rust_vec$##RUST_TYPE##$drop(this);                      \
   }                                                                            \
-  } // extern "C"
-
-STD_VECTOR_OPS(u8, uint8_t);
-STD_VECTOR_OPS(u16, uint16_t);
-STD_VECTOR_OPS(u32, uint32_t);
-STD_VECTOR_OPS(u64, uint64_t);
-STD_VECTOR_OPS(usize, size_t);
-STD_VECTOR_OPS(i8, int8_t);
-STD_VECTOR_OPS(i16, int16_t);
-STD_VECTOR_OPS(i32, int32_t);
-STD_VECTOR_OPS(i64, int64_t);
-STD_VECTOR_OPS(isize, rust::isize);
-STD_VECTOR_OPS(f32, float);
-STD_VECTOR_OPS(f64, double);
+  template <>                                                                  \
+  size_t Vec<CXX_TYPE>::size() const noexcept {                                \
+    return cxxbridge02$rust_vec$##RUST_TYPE##$len(this);                       \
+  }                                                                            \
+  template <>                                                                  \
+  const CXX_TYPE *Vec<CXX_TYPE>::data() const noexcept {                       \
+    return cxxbridge02$rust_vec$##RUST_TYPE##$data(this);                      \
+  }                                                                            \
+  template <>                                                                  \
+  size_t Vec<CXX_TYPE>::stride() noexcept {                                    \
+    return cxxbridge02$rust_vec$##RUST_TYPE##$stride();                        \
+  }
+
+// Usize and isize are the same type as one of the below.
+#define FOR_EACH_SIZED_PRIMITIVE(MACRO)                                        \
+  MACRO(u8, uint8_t)                                                           \
+  MACRO(u16, uint16_t)                                                         \
+  MACRO(u32, uint32_t)                                                         \
+  MACRO(u64, uint64_t)                                                         \
+  MACRO(i8, int8_t)                                                            \
+  MACRO(i16, int16_t)                                                          \
+  MACRO(i32, int32_t)                                                          \
+  MACRO(i64, int64_t)                                                          \
+  MACRO(f32, float)                                                            \
+  MACRO(f64, double)
+
+#define FOR_EACH_PRIMITIVE(MACRO)                                              \
+  FOR_EACH_SIZED_PRIMITIVE(MACRO)                                              \
+  MACRO(usize, size_t)                                                         \
+  MACRO(isize, rust::isize)
+
+extern "C" {
+FOR_EACH_PRIMITIVE(STD_VECTOR_OPS)
+FOR_EACH_SIZED_PRIMITIVE(RUST_VEC_EXTERNS)
+} // extern "C"
+
+namespace rust {
+inline namespace cxxbridge02 {
+FOR_EACH_SIZED_PRIMITIVE(RUST_VEC_OPS)
+} // namespace cxxbridge02
+} // namespace rust
diff --git a/src/cxx_vector.rs b/src/cxx_vector.rs
new file mode 100644
index 0000000..8294044
--- /dev/null
+++ b/src/cxx_vector.rs
@@ -0,0 +1,234 @@
+use std::ffi::c_void;
+use std::fmt::{self, Display};
+use std::marker::PhantomData;
+use std::mem;
+use std::ptr;
+
+/// Binding to C++ `std::vector<T, std::allocator<T>>`.
+///
+/// # Invariants
+///
+/// As an invariant of this API and the static analysis of the cxx::bridge
+/// macro, in Rust code we can never obtain a `CxxVector` by value. Instead in
+/// Rust code we will only ever look at a vector behind a reference or smart
+/// pointer, as in `&CxxVector<T>` or `UniquePtr<CxxVector<T>>`.
+#[repr(C, packed)]
+pub struct CxxVector<T> {
+    _private: [T; 0],
+}
+
+impl<T> CxxVector<T>
+where
+    T: VectorElement,
+{
+    /// Returns the number of elements in the vector.
+    ///
+    /// Matches the behavior of C++ [std::vector\<T\>::size][size].
+    ///
+    /// [size]: https://en.cppreference.com/w/cpp/container/vector/size
+    pub fn len(&self) -> usize {
+        T::__vector_size(self)
+    }
+
+    /// Returns true if the vector contains no elements.
+    ///
+    /// Matches the behavior of C++ [std::vector\<T\>::empty][empty].
+    ///
+    /// [empty]: https://en.cppreference.com/w/cpp/container/vector/empty
+    pub fn is_empty(&self) -> bool {
+        self.len() == 0
+    }
+
+    /// Returns a reference to an element at the given position, or `None` if
+    /// out of bounds.
+    pub fn get(&self, pos: usize) -> Option<&T> {
+        if pos < self.len() {
+            Some(unsafe { T::__get_unchecked(self, pos) })
+        } else {
+            None
+        }
+    }
+
+    /// Returns a reference to an element without doing bounds checking.
+    ///
+    /// This is generally not recommended, use with caution! Calling this method
+    /// with an out-of-bounds index is undefined behavior even if the resulting
+    /// reference is not used.
+    ///
+    /// Matches the behavior of C++
+    /// [std::vector\<T\>::operator\[\]][operator_at].
+    ///
+    /// [operator_at]: https://en.cppreference.com/w/cpp/container/vector/operator_at
+    pub unsafe fn get_unchecked(&self, pos: usize) -> &T {
+        T::__get_unchecked(self, pos)
+    }
+
+    /// Appends an element to the back of the vector.
+    pub fn push_back(&mut self, item: &T) {
+        T::__push_back(self, item);
+    }
+}
+
+pub struct Iter<'a, T> {
+    v: &'a CxxVector<T>,
+    index: usize,
+}
+
+impl<'a, T> IntoIterator for &'a CxxVector<T>
+where
+    T: VectorElement,
+{
+    type Item = &'a T;
+    type IntoIter = Iter<'a, T>;
+
+    fn into_iter(self) -> Self::IntoIter {
+        Iter { v: self, index: 0 }
+    }
+}
+
+impl<'a, T> Iterator for Iter<'a, T>
+where
+    T: VectorElement,
+{
+    type Item = &'a T;
+
+    fn next(&mut self) -> Option<Self::Item> {
+        self.index = self.index + 1;
+        self.v.get(self.index - 1)
+    }
+}
+
+pub struct TypeName<T> {
+    element: PhantomData<T>,
+}
+
+impl<T> TypeName<T> {
+    pub const fn new() -> Self {
+        TypeName {
+            element: PhantomData,
+        }
+    }
+}
+
+impl<T> Display for TypeName<T>
+where
+    T: VectorElement,
+{
+    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
+        write!(formatter, "CxxVector<{}>", T::__NAME)
+    }
+}
+
+// Methods are private; not intended to be implemented outside of cxxbridge
+// codebase.
+#[doc(hidden)]
+pub unsafe trait VectorElement: Sized {
+    const __NAME: &'static dyn Display;
+    fn __vector_size(v: &CxxVector<Self>) -> usize;
+    unsafe fn __get_unchecked(v: &CxxVector<Self>, pos: usize) -> &Self;
+    fn __push_back(v: &CxxVector<Self>, item: &Self);
+    fn __unique_ptr_null() -> *mut c_void;
+    unsafe fn __unique_ptr_raw(raw: *mut CxxVector<Self>) -> *mut c_void;
+    unsafe fn __unique_ptr_get(repr: *mut c_void) -> *const CxxVector<Self>;
+    unsafe fn __unique_ptr_release(repr: *mut c_void) -> *mut CxxVector<Self>;
+    unsafe fn __unique_ptr_drop(repr: *mut c_void);
+}
+
+macro_rules! impl_vector_element_for_primitive {
+    ($ty:ident) => {
+        const_assert_eq!(1, mem::align_of::<CxxVector<$ty>>());
+
+        unsafe impl VectorElement for $ty {
+            const __NAME: &'static dyn Display = &stringify!($ty);
+            fn __vector_size(v: &CxxVector<$ty>) -> usize {
+                extern "C" {
+                    attr! {
+                        #[link_name = concat!("cxxbridge02$std$vector$", stringify!($ty), "$size")]
+                        fn __vector_size(_: &CxxVector<$ty>) -> usize;
+                    }
+                }
+                unsafe { __vector_size(v) }
+            }
+            unsafe fn __get_unchecked(v: &CxxVector<$ty>, pos: usize) -> &$ty {
+                extern "C" {
+                    attr! {
+                        #[link_name = concat!("cxxbridge02$std$vector$", stringify!($ty), "$get_unchecked")]
+                        fn __get_unchecked(_: &CxxVector<$ty>, _: usize) -> *const $ty;
+                    }
+                }
+                &*__get_unchecked(v, pos)
+            }
+            fn __push_back(v: &CxxVector<$ty>, item: &$ty) {
+                extern "C" {
+                    attr! {
+                        #[link_name = concat!("cxxbridge02$std$vector$", stringify!($ty), "$push_back")]
+                        fn __push_back(_: &CxxVector<$ty>, _: &$ty);
+                    }
+                }
+                unsafe { __push_back(v, item) }
+            }
+            fn __unique_ptr_null() -> *mut c_void {
+                extern "C" {
+                    attr! {
+                        #[link_name = concat!("cxxbridge02$unique_ptr$std$vector$", stringify!($ty), "$null")]
+                        fn __unique_ptr_null(this: *mut *mut c_void);
+                    }
+                }
+                let mut repr = ptr::null_mut::<c_void>();
+                unsafe { __unique_ptr_null(&mut repr) }
+                repr
+            }
+            unsafe fn __unique_ptr_raw(raw: *mut CxxVector<Self>) -> *mut c_void {
+                extern "C" {
+                    attr! {
+                        #[link_name = concat!("cxxbridge02$unique_ptr$std$vector$", stringify!($ty), "$raw")]
+                        fn __unique_ptr_raw(this: *mut *mut c_void, raw: *mut CxxVector<$ty>);
+                    }
+                }
+                let mut repr = ptr::null_mut::<c_void>();
+                __unique_ptr_raw(&mut repr, raw);
+                repr
+            }
+            unsafe fn __unique_ptr_get(repr: *mut c_void) -> *const CxxVector<Self> {
+                extern "C" {
+                    attr! {
+                        #[link_name = concat!("cxxbridge02$unique_ptr$std$vector$", stringify!($ty), "$get")]
+                        fn __unique_ptr_get(this: *const *mut c_void) -> *const CxxVector<$ty>;
+                    }
+                }
+                __unique_ptr_get(&repr)
+            }
+            unsafe fn __unique_ptr_release(mut repr: *mut c_void) -> *mut CxxVector<Self> {
+                extern "C" {
+                    attr! {
+                        #[link_name = concat!("cxxbridge02$unique_ptr$std$vector$", stringify!($ty), "$release")]
+                        fn __unique_ptr_release(this: *mut *mut c_void) -> *mut CxxVector<$ty>;
+                    }
+                }
+                __unique_ptr_release(&mut repr)
+            }
+            unsafe fn __unique_ptr_drop(mut repr: *mut c_void) {
+                extern "C" {
+                    attr! {
+                        #[link_name = concat!("cxxbridge02$unique_ptr$std$vector$", stringify!($ty), "$drop")]
+                        fn __unique_ptr_drop(this: *mut *mut c_void);
+                    }
+                }
+                __unique_ptr_drop(&mut repr);
+            }
+        }
+    };
+}
+
+impl_vector_element_for_primitive!(u8);
+impl_vector_element_for_primitive!(u16);
+impl_vector_element_for_primitive!(u32);
+impl_vector_element_for_primitive!(u64);
+impl_vector_element_for_primitive!(usize);
+impl_vector_element_for_primitive!(i8);
+impl_vector_element_for_primitive!(i16);
+impl_vector_element_for_primitive!(i32);
+impl_vector_element_for_primitive!(i64);
+impl_vector_element_for_primitive!(isize);
+impl_vector_element_for_primitive!(f32);
+impl_vector_element_for_primitive!(f64);
diff --git a/src/lib.rs b/src/lib.rs
index e23be69..e4ef8f2 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -311,6 +311,8 @@
 //! <tr><td><a href="struct.CxxString.html">CxxString</a></td><td>std::string</td><td><sup><i>cannot be passed by value</i></sup></td></tr>
 //! <tr><td>Box&lt;T&gt;</td><td>rust::Box&lt;T&gt;</td><td><sup><i>cannot hold opaque C++ type</i></sup></td></tr>
 //! <tr><td><a href="struct.UniquePtr.html">UniquePtr&lt;T&gt;</a></td><td>std::unique_ptr&lt;T&gt;</td><td><sup><i>cannot hold opaque Rust type</i></sup></td></tr>
+//! <tr><td>Vec&lt;T&gt;</td><td>rust::Vec&lt;T&gt;</td><td><sup><i>cannot hold opaque C++ type</i></sup></td></tr>
+//! <tr><td><a href="struct.CxxVector.html">CxxVector&lt;T&gt;</a></td><td>std::vector&lt;T&gt;</td><td><sup><i>cannot hold opaque Rust type</i></sup></td></tr>
 //! <tr><td>fn(T, U) -&gt; V</td><td>rust::Fn&lt;V(T, U)&gt;</td><td><sup><i>only passing from Rust to C++ is implemented so far</i></sup></td></tr>
 //! <tr><td>Result&lt;T&gt;</td><td>throw/catch</td><td><sup><i>allowed as return type only</i></sup></td></tr>
 //! </table>
@@ -325,11 +327,9 @@
 //!
 //! <table>
 //! <tr><th>name in Rust</th><th>name in C++</th></tr>
-//! <tr><td>Vec&lt;T&gt;</td><td><sup><i>tbd</i></sup></td></tr>
 //! <tr><td>BTreeMap&lt;K, V&gt;</td><td><sup><i>tbd</i></sup></td></tr>
 //! <tr><td>HashMap&lt;K, V&gt;</td><td><sup><i>tbd</i></sup></td></tr>
 //! <tr><td>Arc&lt;T&gt;</td><td><sup><i>tbd</i></sup></td></tr>
-//! <tr><td><sup><i>tbd</i></sup></td><td>std::vector&lt;T&gt;</td></tr>
 //! <tr><td><sup><i>tbd</i></sup></td><td>std::map&lt;K, V&gt;</td></tr>
 //! <tr><td><sup><i>tbd</i></sup></td><td>std::unordered_map&lt;K, V&gt;</td></tr>
 //! <tr><td><sup><i>tbd</i></sup></td><td>std::shared_ptr&lt;T&gt;</td></tr>
@@ -358,8 +358,11 @@ extern crate link_cplusplus;
 
 #[macro_use]
 mod assert;
+#[macro_use]
+mod concat;
 
 mod cxx_string;
+mod cxx_vector;
 mod error;
 mod exception;
 mod function;
@@ -374,28 +377,26 @@ mod rust_vec;
 mod syntax;
 mod unique_ptr;
 mod unwind;
-mod vector;
 
 pub use crate::cxx_string::CxxString;
+pub use crate::cxx_vector::CxxVector;
 pub use crate::exception::Exception;
-pub use crate::rust_vec::RustVec;
 pub use crate::unique_ptr::UniquePtr;
-pub use crate::vector::RealVector;
-pub use crate::vector::VectorIntoIterator;
 pub use cxxbridge_macro::bridge;
 
 // Not public API.
 #[doc(hidden)]
 pub mod private {
+    pub use crate::cxx_vector::VectorElement;
     pub use crate::function::FatFunction;
     pub use crate::opaque::Opaque;
     pub use crate::result::{r#try, Result};
     pub use crate::rust_sliceu8::RustSliceU8;
     pub use crate::rust_str::RustStr;
     pub use crate::rust_string::RustString;
+    pub use crate::rust_vec::RustVec;
     pub use crate::unique_ptr::UniquePtrTarget;
     pub use crate::unwind::catch_unwind;
-    pub use crate::vector::VectorTarget;
 }
 
 use crate::error::Result;
diff --git a/src/rust_vec.rs b/src/rust_vec.rs
index a28570d..d5de489 100644
--- a/src/rust_vec.rs
+++ b/src/rust_vec.rs
@@ -1,18 +1,22 @@
-use crate::vector::RealVector;
-use crate::vector::VectorTarget;
+use std::mem;
+use std::ptr;
 
 #[repr(C)]
-pub struct RustVec<T: VectorTarget<T>> {
+pub struct RustVec<T> {
     repr: Vec<T>,
 }
 
-impl<T: VectorTarget<T>> RustVec<T> {
+impl<T> RustVec<T> {
+    pub fn new() -> Self {
+        RustVec { repr: Vec::new() }
+    }
+
     pub fn from(v: Vec<T>) -> Self {
         RustVec { repr: v }
     }
 
     pub fn from_ref(v: &Vec<T>) -> &Self {
-        unsafe { std::mem::transmute::<&Vec<T>, &RustVec<T>>(v) }
+        unsafe { &*(v as *const Vec<T> as *const RustVec<T>) }
     }
 
     pub fn into_vec(self) -> Vec<T> {
@@ -31,9 +35,58 @@ impl<T: VectorTarget<T>> RustVec<T> {
         self.repr.len()
     }
 
-    pub fn into_vector(&self, vec: &mut RealVector<T>) {
-        for item in &self.repr {
-            vec.push_back(item);
-        }
+    pub fn as_ptr(&self) -> *const T {
+        self.repr.as_ptr()
     }
 }
+
+macro_rules! rust_vec_shims_for_primitive {
+    ($ty:ident) => {
+        const_assert_eq!(mem::size_of::<[usize; 3]>(), mem::size_of::<Vec<$ty>>());
+        const_assert_eq!(mem::align_of::<usize>(), mem::align_of::<Vec<$ty>>());
+
+        const _: () = {
+            attr! {
+                #[export_name = concat!("cxxbridge02$rust_vec$", stringify!($ty), "$new")]
+                unsafe extern "C" fn __new(this: *mut RustVec<$ty>) {
+                    ptr::write(this, RustVec::new());
+                }
+            }
+            attr! {
+                #[export_name = concat!("cxxbridge02$rust_vec$", stringify!($ty), "$drop")]
+                unsafe extern "C" fn __drop(this: *mut RustVec<$ty>) {
+                    ptr::drop_in_place(this);
+                }
+            }
+            attr! {
+                #[export_name = concat!("cxxbridge02$rust_vec$", stringify!($ty), "$len")]
+                unsafe extern "C" fn __len(this: *const RustVec<$ty>) -> usize {
+                    (*this).len()
+                }
+            }
+            attr! {
+                #[export_name = concat!("cxxbridge02$rust_vec$", stringify!($ty), "$data")]
+                unsafe extern "C" fn __data(this: *const RustVec<$ty>) -> *const $ty {
+                    (*this).as_ptr()
+                }
+            }
+            attr! {
+                #[export_name = concat!("cxxbridge02$rust_vec$", stringify!($ty), "$stride")]
+                unsafe extern "C" fn __stride() -> usize {
+                    mem::size_of::<$ty>()
+                }
+            }
+        };
+    };
+}
+
+rust_vec_shims_for_primitive!(u8);
+rust_vec_shims_for_primitive!(u16);
+rust_vec_shims_for_primitive!(u32);
+rust_vec_shims_for_primitive!(u64);
+rust_vec_shims_for_primitive!(i8);
+rust_vec_shims_for_primitive!(i16);
+rust_vec_shims_for_primitive!(i32);
+rust_vec_shims_for_primitive!(i64);
+rust_vec_shims_for_primitive!(f32);
+rust_vec_shims_for_primitive!(f64);
diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index b50e870..98b4b7d 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -1,4 +1,5 @@
 use crate::cxx_string::CxxString;
+use crate::cxx_vector::{self, CxxVector, VectorElement};
 use std::ffi::c_void;
 use std::fmt::{self, Debug, Display};
 use std::marker::PhantomData;
@@ -149,7 +150,7 @@ where
 // codebase.
 pub unsafe trait UniquePtrTarget {
     #[doc(hidden)]
-    const __NAME: &'static str;
+    const __NAME: &'static dyn Display;
     #[doc(hidden)]
     fn __null() -> *mut c_void;
     #[doc(hidden)]
@@ -186,7 +187,7 @@ extern "C" {
 }
 
 unsafe impl UniquePtrTarget for CxxString {
-    const __NAME: &'static str = "CxxString";
+    const __NAME: &'static dyn Display = &"CxxString";
     fn __null() -> *mut c_void {
         let mut repr = ptr::null_mut::<c_void>();
         unsafe { unique_ptr_std_string_null(&mut repr) }
@@ -207,3 +208,25 @@ unsafe impl UniquePtrTarget for CxxString {
         unique_ptr_std_string_drop(&mut repr);
     }
 }
+
+unsafe impl<T> UniquePtrTarget for CxxVector<T>
+where
+    T: VectorElement + 'static,
+{
+    const __NAME: &'static dyn Display = &cxx_vector::TypeName::<T>::new();
+    fn __null() -> *mut c_void {
+        T::__unique_ptr_null()
+    }
+    unsafe fn __raw(raw: *mut Self) -> *mut c_void {
+        T::__unique_ptr_raw(raw)
+    }
+    unsafe fn __get(repr: *mut c_void) -> *const Self {
+        T::__unique_ptr_get(repr)
+    }
+    unsafe fn __release(repr: *mut c_void) -> *mut Self {
+        T::__unique_ptr_release(repr)
+    }
+    unsafe fn __drop(repr: *mut c_void) {
+        T::__unique_ptr_drop(repr);
+    }
+}
diff --git a/syntax/atom.rs b/syntax/atom.rs
index c68b3fe..eeea831 100644
--- a/syntax/atom.rs
+++ b/syntax/atom.rs
@@ -42,43 +42,6 @@ impl Atom {
             _ => None,
         }
     }
-
-    pub fn to_cxx(&self) -> &'static str {
-        use self::Atom::*;
-        match self {
-            Bool => "bool",
-            U8 => "uint8_t",
-            U16 => "uint16_t",
-            U32 => "uint32_t",
-            U64 => "uint64_t",
-            Usize => "size_t",
-            I8 => "int8_t",
-            I16 => "int16_t",
-            I32 => "int32_t",
-            I64 => "int64_t",
-            Isize => "::rust::isize",
-            F32 => "float",
-            F64 => "double",
-            CxxString => "::std::string",
-            RustString => "::rust::String",
-        }
-    }
-
-    pub fn is_valid_vector_target(&self) -> bool {
-        use self::Atom::*;
-        *self == U8
-            || *self == U16
-            || *self == U32
-            || *self == U64
-            || *self == Usize
-            || *self == I8
-            || *self == I16
-            || *self == I32
-            || *self == I64
-            || *self == Isize
-            || *self == F32
-            || *self == F64
-    }
 }
 
 impl PartialEq<Atom> for Ident {
diff --git a/syntax/check.rs b/syntax/check.rs
index 387f9a6..0c75de8 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -29,9 +29,9 @@ fn do_typecheck(cx: &mut Check) {
         match ty {
             Type::Ident(ident) => check_type_ident(cx, ident),
             Type::RustBox(ptr) => check_type_box(cx, ptr),
-            Type::RustVec(ptr) => check_type_vec(cx, ptr),
+            Type::RustVec(ty) => check_type_rust_vec(cx, ty),
             Type::UniquePtr(ptr) => check_type_unique_ptr(cx, ptr),
-            Type::Vector(ptr) => check_type_vector(cx, ptr),
+            Type::CxxVector(ptr) => check_type_cxx_vector(cx, ptr),
             Type::Ref(ty) => check_type_ref(cx, ty),
             Type::Slice(ty) => check_type_slice(cx, ty),
             _ => {}
@@ -89,19 +89,22 @@ fn check_type_box(cx: &mut Check, ptr: &Ty1) {
     cx.error(ptr, "unsupported target type of Box");
 }
 
-fn check_type_vec(cx: &mut Check, ptr: &Ty1) {
-    // Vec can contain either user-defined type or u8
-    if let Type::Ident(ident) = &ptr.inner {
-        if Atom::from(ident).map(|a| a.is_valid_vector_target()) == Some(true) {
-            return;
-        } else if cx.types.cxx.contains(ident) {
-            cx.error(ptr, error::VEC_CXX_TYPE.msg);
-        } else {
+fn check_type_rust_vec(cx: &mut Check, ty: &Ty1) {
+    if let Type::Ident(ident) = &ty.inner {
+        if cx.types.cxx.contains(ident) {
+            cx.error(ty, "Rust Vec containing C++ type is not supported yet");
             return;
         }
+
+        match Atom::from(ident) {
+            None | Some(U8) | Some(U16) | Some(U32) | Some(U64) | Some(Usize) | Some(I8)
+            | Some(I16) | Some(I32) | Some(I64) | Some(Isize) | Some(F32) | Some(F64) => return,
+            Some(Bool) | Some(RustString) => { /* todo */ }
+            Some(CxxString) => {}
+        }
     }
 
-    cx.error(ptr, "unsupported target type of Vec");
+    cx.error(ty, "unsupported element type of Vec");
 }
 
 fn check_type_unique_ptr(cx: &mut Check, ptr: &Ty1) {
@@ -114,28 +117,30 @@ fn check_type_unique_ptr(cx: &mut Check, ptr: &Ty1) {
             None | Some(CxxString) => return,
             _ => {}
         }
-    } else if let Type::Vector(_) = &ptr.inner {
+    } else if let Type::CxxVector(_) = &ptr.inner {
         return;
     }
 
     cx.error(ptr, "unsupported unique_ptr target type");
 }
 
-fn check_type_vector(cx: &mut Check, ptr: &Ty1) {
+fn check_type_cxx_vector(cx: &mut Check, ptr: &Ty1) {
     if let Type::Ident(ident) = &ptr.inner {
         if cx.types.rust.contains(ident) {
-            cx.error(ptr, "vector of a Rust type is not supported yet");
+            cx.error(
+                ptr,
+                "C++ vector containing a Rust type is not supported yet",
+            );
         }
 
         match Atom::from(ident) {
-            None => return,
-            Some(atom) => {
-                if atom.is_valid_vector_target() {
-                    return;
-                }
-            }
+            None | Some(U8) | Some(U16) | Some(U32) | Some(U64) | Some(Usize) | Some(I8)
+            | Some(I16) | Some(I32) | Some(I64) | Some(Isize) | Some(F32) | Some(F64) => return,
+            Some(CxxString) => { /* todo */ }
+            Some(Bool) | Some(RustString) => {}
         }
     }
+
     cx.error(ptr, "unsupported vector target type");
 }
 
@@ -285,7 +290,12 @@ fn check_multiple_arg_lifetimes(cx: &mut Check, efn: &ExternFn) {
 }
 
 fn check_reserved_name(cx: &mut Check, ident: &Ident) {
-    if ident == "Box" || ident == "UniquePtr" || Atom::from(ident).is_some() {
+    if ident == "Box"
+        || ident == "UniquePtr"
+        || ident == "Vec"
+        || ident == "CxxVector"
+        || Atom::from(ident).is_some()
+    {
         cx.error(ident, "reserved name");
     }
 }
@@ -293,7 +303,7 @@ fn check_reserved_name(cx: &mut Check, ident: &Ident) {
 fn is_unsized(cx: &mut Check, ty: &Type) -> bool {
     let ident = match ty {
         Type::Ident(ident) => ident,
-        Type::Slice(_) | Type::Void(_) => return true,
+        Type::CxxVector(_) | Type::Slice(_) | Type::Void(_) => return true,
         _ => return false,
     };
     ident == CxxString || cx.types.cxx.contains(ident) || cx.types.rust.contains(ident)
@@ -351,7 +361,7 @@ fn describe(cx: &mut Check, ty: &Type) -> String {
         Type::UniquePtr(_) => "unique_ptr".to_owned(),
         Type::Ref(_) => "reference".to_owned(),
         Type::Str(_) => "&str".to_owned(),
-        Type::Vector(_) => "vector".to_owned(),
+        Type::CxxVector(_) => "C++ vector".to_owned(),
         Type::Slice(_) => "slice".to_owned(),
         Type::SliceRefU8(_) => "&[u8]".to_owned(),
         Type::Fn(_) => "function pointer".to_owned(),
